#ifndef BUILD_nodo_multipv
#define BUILD_nodo_multipv
#include "RobboLito.h"
#define RETURN(x) return(x)

#include "sorvegliare.h"
tipo_lista_mossa RADICE_LISTA_MOSSA[256];
void APPLY_SORT (int NUMERO, tipo_mpv* mpv)
{
  tipo_mpv *p;
  int s, x;
  for (s = 0; s < NUMERO && mpv[s].mossa; s++)
    {
      if (s == 0)
	continue;
      p = &mpv[s];
      while (p != mpv && p->valu > (p-1)->valu)
	{
	  x = p->valu;
	  p->valu = (p - 1)->valu;
	  (p - 1)->valu = x;
	  x = p->mossa;
	  p->mossa = (p - 1)->mossa;
	  (p - 1)->mossa = x;
	  p--;
	}	
    }
}

#include "nodo_multipv.c"
#include "bianco.h"
#else
#include "nero.h"
#endif

int
mio_nodo_multipv (tipo_posizione *POSIZIONE, int abisso)
{
  int CNT, valu_migliore, cnt, scacco_mossa, abisso_nuovo, v;
  tipo_lista_mossa *p;
  tipo_dinamico *POSIZIONE0 = DINAMICO;
  uint32 mossa;
  int ESTENSIONE;
  int ai;
  int i, j, x;
  int ALTO = VALU_MATTO;
  int BASSO = -VALU_MATTO;
  int GOOD_MOVES = 0;

  for (i = 0; i < 256; i++)
    MPV[i].mossa = MPV[i].valu = 0;
  TRASMISSIONE ("info depth %d\n", abisso / 2);
  CNT = 0;
  for (p = RADICE_LISTA_MOSSA; p->mossa; p++)
    {
      CNT++;
      p->mossa &= 0x7fff;
    }
  p = RADICE_LISTA_MOSSA;
  v = valu_migliore = -VALU_INFINITO;
  cnt = 0; /* SMP ? */
  while ((mossa = p->mossa))
    {
      FARE (POSIZIONE, mossa);
      chiamata_valu_piena (mossa);
      scacco_mossa = (mossa_scacco != 0);
      ESTENSIONE =0;
      ai = AI (mossa);
      if (POSIZIONE1->cattura || scacco_mossa ||
	  pedone_libero_mossa (ai, TRAVERSA_QUARTA (ai)))
	ESTENSIONE = 1;
      abisso_nuovo = abisso - 2 + ESTENSIONE;
      if (ANALISI && abisso >= 24)
	TRASMISSIONE ("info currmove %s currmovenumber %d\n",
		      mossa_notazione (mossa, STRING1),
		      (p - RADICE_LISTA_MOSSA) + 1);
      if (GOOD_MOVES < MULTI_PV || abisso <= 2)
	v = -tuo_nodo_pv (POSIZIONE, -ALTO, -BASSO, abisso_nuovo, scacco_mossa);
      else
	{
	  if (abisso_nuovo <= 7)
	    {
	      if (scacco_mossa)
		v = -tuo_cerca_mezzo_scacco (POSIZIONE, -BASSO, abisso_nuovo);
	      else
		v = -tuo_cerca_mezzo (POSIZIONE, -BASSO, abisso_nuovo);
	    }
	  else
	    {
	      if (abisso_nuovo >= 16 && ANALISI) /* ANALISI es VERO */
		{
		  int an = abisso_nuovo - 12;
		  v = VALU_INFINITO;
		  while (an <= abisso_nuovo && v > BASSO)
		    {
		      v = -tuo_nodo_pv (POSIZIONE, -BASSO - 1, -BASSO, an, scacco_mossa);
		      an += 4;
		    }
		  if (an > abisso_nuovo)
		      goto DEC;
		}
	      if (scacco_mossa)
		v = -tuo_nodo_tagliato_scacco (POSIZIONE, -BASSO, abisso_nuovo);
	      else
		v = -tuo_nodo_tagliato (POSIZIONE, -BASSO, abisso_nuovo);
	    }
	  if (v > BASSO)
	    v = -tuo_nodo_pv (POSIZIONE, -BASSO - 1, -BASSO, abisso_nuovo, scacco_mossa);
	DEC:
	  if (v > BASSO)
	    v = -tuo_nodo_pv (POSIZIONE, -ALTO, -BASSO, abisso_nuovo, scacco_mossa);
	  if (v <= BASSO)
	    v = BASSO;
	} /* NORMALE */
      ANNULLA (POSIZIONE, mossa);
      CHECK_HALT ();
      if (v > BASSO)
	{
	  MPV[GOOD_MOVES].mossa = mossa;
	  MPV[GOOD_MOVES++].valu = v;
	  APPLY_SORT (GOOD_MOVES, MPV);
	  if (GOOD_MOVES >= MULTI_PV)
	    BASSO = MPV[MULTI_PV - 1].valu;
	  else
	    BASSO = MASSIMO (MPV[0].valu - MULTI_CENTI_PAWN_PV, -VALU_MATTO);
	  radice_mossa = MPV[0].mossa;
	  radice_valu = MPV[0].valu;
	  informazione (POSIZIONE, orologio () - OROLOGIO,
			-VALU_MATTO, MPV[0].valu, VALU_MATTO);
	}
      p++;
    }
  for (i = 0; i < GOOD_MOVES; i++)
    {
      for (j = 0; j < CNT; j++)
	{
	  if (RADICE_LISTA_MOSSA[j].mossa == MPV[i].mossa)
	    {
	      x = RADICE_LISTA_MOSSA[i].mossa;
	      RADICE_LISTA_MOSSA[i].mossa = RADICE_LISTA_MOSSA[j].mossa;
	      RADICE_LISTA_MOSSA[j].mossa = x;
	      break;
	    }
	}
    }
  radice_abisso = abisso;
  informazione (POSIZIONE, orologio () - OROLOGIO, -VALU_MATTO, MPV[0].valu, VALU_MATTO);
  return MPV[0].valu;
}
